<?php
/**
 * Pagadito.
 * 
 * Pagadito Payment Method v1.2.2
 * 
 * Este programa es Software Libre: Usted puede redistribuirlo y/o modificarlo
 * bajo los terminos de la Licencia Publica General Reducida de GNU (GNU Lesser
 * Public Licence), tal como se encuentra publicada por la Free Software
 * Foundation, ya sea por su version 3 o cualquier otra version superior.
 * 
 * Este programa es distribuido en el espiritu de que sea util, pero SIN NINGUNA
 * GARANTIA; sin tampoco garantia implicita de MERCANTIBILIDAD o ADAPTABILIDAD
 * PARA UN USO PARTICULAR. Vea la licencia GNU LGPL para mayores detalles.
 * 
 * @package     pagadito_osc-v1.2.2
 * @copyright   Copyright (c) 2015 - Pagadito, S. de R.L. (https://www.pagadito.com)
 * @license     http://www.gnu.org/licenses/lgpl.html
 * @author      Pagadito Development Team <developers@pagadito.com>
 */
class pagadito_osc {
    var $code, $title, $description, $enabled;

// class constructor
    function pagadito_osc() {
        global $order;
        $this->signature = 'pagadito|1.2.2';
        $this->api_version = '1.1.0';
        $this->code = 'pagadito_osc';
        $this->title = MODULE_PAYMENT_PAGADITO_TEXT_TITLE;
        $this->public_title = MODULE_PAYMENT_PAGADITO_TEXT_PUBLIC_TITLE;
        $this->description = MODULE_PAYMENT_PAGADITO_TEXT_DESCRIPTION;
        $this->sort_order = MODULE_PAYMENT_PAGADITO_SORT_ORDER;
        $this->enabled = ((MODULE_PAYMENT_PAGADITO_STATUS == 'True') ? true : false);
        if (is_object($order)) $this->update_status();
    }

// class methods
    function update_status() {
        global $order;
        if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAGADITO_ZONE > 0) ) {
            $check_flag = false;
            $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAGADITO_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
            while ($check = tep_db_fetch_array($check_query)) {
                if ($check['zone_id'] < 1) {
                    $check_flag = true;
                    break;
                } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
                    $check_flag = true;
                    break;
                }
            }
            if ($check_flag == false) {
                $this->enabled = false;
            }
        }
    }

    function javascript_validation() {
        return false;
    }

    function selection() {
        return array('id' => $this->code,
                   'module' => $this->public_title);
    }

    function pre_confirmation_check() {
        return false;
    }

    function confirmation() {
        return false;
    }

    function process_button() {
        return false;
    }

    function before_process() {
        global $HTTP_GET_VARS, $HTTP_POST_VARS, $insert_id, $customer_id, $order, $currency, $order_totals, $order_id, $cartID, $cart;
        require_once DIR_FS_CATALOG.'ext/modules/payment/pagadito_osc/Pagadito.php';
        $uid = MODULE_PAYMENT_PAGADITO_UID;
        $wsk = MODULE_PAYMENT_PAGADITO_WSK;
        $Pagadito = new Pagadito($uid, $wsk);
        if (MODULE_PAYMENT_PAGADITO_PRODUCTION == 'SandBox') {
            $Pagadito->mode_sandbox_on();
        }
        if(isset($_GET["token"])){
            //consulting transaction status with Pagadito
            if($Pagadito->connect()){
                if($Pagadito->get_status($_GET["token"])){
                    $query_id = tep_db_query("SELECT orders_id FROM orders_status_history WHERE comments = '".$_GET["token"]."'");
                    $row_id = tep_db_fetch_array($query_id);
                    switch($Pagadito->get_rs_status()){
                        case "REGISTERED":
                            $sql_data_array = array('orders_id' => $row_id['orders_id'],
                                                   'orders_status_id' => MODULE_PAYMENT_PAGADITO_ORDER_STATUS_REGISTERED,
                                                   'date_added' => 'now()',
                                                   'customer_notified' => '0',
                                                   'comments' => 'REGISTERED');
                            tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                            tep_db_query("update " . TABLE_ORDERS . " set orders_status = ".MODULE_PAYMENT_PAGADITO_ORDER_STATUS_REGISTERED.", last_modified = now() where orders_id = '".$row_id['orders_id']."'");
                            tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_TRANS_REGISTERED, 'SSL', true));
                            break;
                        case "COMPLETED":
                            $sql_data_array = array('orders_id' => $row_id['orders_id'],
                                                   'orders_status_id' => MODULE_PAYMENT_PAGADITO_ORDER_STATUS_COMPLETED,
                                                   'date_added' => 'now()',
                                                   'customer_notified' => '0',
                                                   'comments' => 'Ref Pagadito: '.$Pagadito->get_rs_reference());
                            tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                            tep_db_query("update " . TABLE_ORDERS . " set orders_status = ".MODULE_PAYMENT_PAGADITO_ORDER_STATUS_COMPLETED.", last_modified = now() where orders_id = '".$row_id['orders_id']."'");
                            break;
                        case "FAILED":
                            $sql_data_array = array('orders_id' => $row_id['orders_id'],
                                                   'orders_status_id' => MODULE_PAYMENT_PAGADITO_ORDER_STATUS_FAILED,
                                                   'date_added' => 'now()',
                                                   'customer_notified' => '0',
                                                   'comments' => 'FAILED');
                            tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                            tep_db_query("update " . TABLE_ORDERS . " set orders_status = ".MODULE_PAYMENT_PAGADITO_ORDER_STATUS_FAILED.", last_modified = now() where orders_id = '".$row_id['orders_id']."'");
                            tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_TRANS_FAILED, 'SSL', true));
                            break;
                        case "CANCELED":
                        case "EXPIRED":
                        default :
                            
                            $sql_data_array = array('orders_id' => $row_id['orders_id'],
                                                   'orders_status_id' => MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED,
                                                   'date_added' => 'now()',
                                                   'customer_notified' => '0',
                                                   'comments' => 'CANCELED');
                            tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                            tep_db_query("update " . TABLE_ORDERS . " set orders_status = ".MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED.", last_modified = now() where orders_id = '".$row_id['orders_id']."'");
                            tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_TRANS_CANCELED, 'SSL', true));
                            break;
                    }
                }
                else{
                    tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_NO_GET_STATUS, 'SSL', true));
                }
            }
            else{
                tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_NO_CONNECT, 'SSL', true));
            }
            $cart->reset(true);
            // unregister session variables used during checkout
            tep_session_unregister('sendto');
            tep_session_unregister('billto');
            tep_session_unregister('shipping');
            tep_session_unregister('payment');
            tep_session_unregister('comments');
            tep_redirect(tep_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL'));
        }
        $order->info['comments'] = "Pagadito";
    }     

    function after_process() {
        global $HTTP_GET_VARS, $HTTP_POST_VARS, $insert_id, $customer_id, $order, $currency, $order_totals, $order_id, $cartID;
	require_once DIR_FS_CATALOG.'ext/modules/payment/pagadito_osc/Pagadito.php';
        $uid = MODULE_PAYMENT_PAGADITO_UID;
        $wsk = MODULE_PAYMENT_PAGADITO_WSK;
        $Pagadito = new Pagadito($uid, $wsk);
        if (MODULE_PAYMENT_PAGADITO_PRODUCTION == 'SandBox') {
            $Pagadito->mode_sandbox_on();
        }
        if(!isset($_GET["token"])){
            //processing transaction with Pagadito
            if($Pagadito->connect()){
                //updating order status
                $sql_data_array = array('orders_id' => $insert_id,
                                      'orders_status_id' => '1', 
                                      'date_added' => 'now()', 
                                      'customer_notified' => '0',
                                      'comments' => $Pagadito->get_rs_value());
                tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                //loading products
                foreach($order->products as $product){
                    $Pagadito->add_detail($product["qty"], $product["name"], str_replace(',','',number_format($product["final_price"], 2)), HTTP_SERVER.DIR_WS_HTTP_CATALOG."product_info.php?products_id=".$product["id"]);
                }
                //loading shipping and taxes
                $Pagadito->add_detail(1, $order->info["shipping_method"], $order->info["shipping_cost"]);
                //switching currency
                switch($order->info["currency"]){
                    case "CRC":
                        $Pagadito->change_currency_crc();
                        break;
                    case "DOP":
                        $Pagadito->change_currency_dop();
                        break;
                    case "GTQ":
                        $Pagadito->change_currency_gtq();
                        break;
                    case "HNL":
                        $Pagadito->change_currency_hnl();
                        break;
                    case "NIO":
                        $Pagadito->change_currency_nio();
                        break;
                    case "PAB":
                        $Pagadito->change_currency_pab();
                        break;
                    case "USD":
                    default:
                        $Pagadito->change_currency_usd();
                        break;
                }
                if(!$Pagadito->exec_trans($insert_id)){
                    $sql_data_array = array('orders_id' => $insert_id,
                                      'orders_status_id' => MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED, 
                                      'date_added' => 'now()', 
                                      'customer_notified' => '0',
                                      'comments' => "Error");
                    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                    tep_db_query("update " . TABLE_ORDERS . " set orders_status = ".MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED.", last_modified = now() where orders_id = '".$insert_id."'");
                    tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_NO_EXEC_TRANS, 'SSL', true));
                }
            }
            else{
                $sql_data_array = array('orders_id' => $insert_id,
                                      'orders_status_id' => MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED, 
                                      'date_added' => 'now()', 
                                      'customer_notified' => '0',
                                      'comments' => "Error");
                tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
                tep_db_query("update " . TABLE_ORDERS . " set orders_status = ".MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED.", last_modified = now() where orders_id = '".$insert_id."'");
                tep_redirect(tep_href_link(FILENAME_CHECKOUT_CONFIRMATION, 'error_message='.MODULE_PAYMENT_PAGADITO_ERROR_NO_CONNECT, 'SSL', true));
            }
        }
    }

    function get_error() {
        return false;
    }

    function check() {
        if (!isset($this->_check)) {
            $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAGADITO_STATUS'");
            $this->_check = tep_db_num_rows($check_query);
        }
        return $this->_check;
    }

    function install() {
        
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Pagadito Module', 'MODULE_PAYMENT_PAGADITO_STATUS', 'True', 'Enable the Pagadito Plugin', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Production or SandBox', 'MODULE_PAYMENT_PAGADITO_PRODUCTION', 'SandBox', 'Set to SandBox if testing, Production for running live transactions', '6', '1', 'tep_cfg_select_option(array(\'Production\', \'SandBox\'), ', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('UID', 'MODULE_PAYMENT_PAGADITO_UID', '0', 'Your UID from Pagadito', '6', '2', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('WSK', 'MODULE_PAYMENT_PAGADITO_WSK', '0', 'Your WSK from Pagadito', '6', '3', now())");
        tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAGADITO_SORT_ORDER', '1', 'Sort order of display. Lowest is displayed first.', '6', '4', now())");
        $stock_query = tep_db_query("select ifnull(max(orders_status_id), 0) + 1 new_orders_status_id from ".TABLE_ORDERS_STATUS);
        if (tep_db_num_rows($stock_query) > 0) {
            $stock_values = tep_db_fetch_array($stock_query);
            $new_orders_status_id = $stock_values["new_orders_status_id"];
            tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name, public_flag, downloads_flag) values ($new_orders_status_id, 1, 'Pagadito registered', 0, 0)");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Registered Status', 'MODULE_PAYMENT_PAGADITO_ORDER_STATUS_REGISTERED', $new_orders_status_id, 'Set the status of orders registered by Pagadito.', '6', '5', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
            $new_orders_status_id++;
            tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name, public_flag, downloads_flag) values ($new_orders_status_id, 1, 'Pagadito completed', 1, 1)");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Completed Status', 'MODULE_PAYMENT_PAGADITO_ORDER_STATUS_COMPLETED', $new_orders_status_id, 'Set the status of orders completed by Pagadito.', '6', '6', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
            $new_orders_status_id++;
            tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name, public_flag, downloads_flag) values ($new_orders_status_id, 1, 'Pagadito failed', 0, 0)");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Failed Status', 'MODULE_PAYMENT_PAGADITO_ORDER_STATUS_FAILED', $new_orders_status_id, 'Set the status of orders failed by Pagadito.', '6', '7', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
            $new_orders_status_id++;
            tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name, public_flag, downloads_flag) values ($new_orders_status_id, 1, 'Pagadito canceled', 0, 0)");
            tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Canceled Status', 'MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED', $new_orders_status_id, 'Set the status of orders canceled.', '6', '8', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
        }
    }

    function remove() {
        tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        tep_db_query("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name in ('" . implode("', '", $this->keys_orders_status()) . "')");
    }

    function keys() {
        return array('MODULE_PAYMENT_PAGADITO_STATUS','MODULE_PAYMENT_PAGADITO_PRODUCTION','MODULE_PAYMENT_PAGADITO_UID','MODULE_PAYMENT_PAGADITO_WSK','MODULE_PAYMENT_PAGADITO_SORT_ORDER','MODULE_PAYMENT_PAGADITO_ORDER_STATUS_REGISTERED','MODULE_PAYMENT_PAGADITO_ORDER_STATUS_COMPLETED','MODULE_PAYMENT_PAGADITO_ORDER_STATUS_FAILED','MODULE_PAYMENT_PAGADITO_ORDER_STATUS_CANCELED');
    }
    
    function keys_orders_status(){
        return array('Pagadito registered','Pagadito completed','Pagadito failed','Pagadito canceled');
    }
  
}
?>
